/*
 * File:   Mellon-1.c
 * Author: LaV
 * PCB "Mellon - 1"
 * Created on 03  2017 ., 1:51
 * omments:
 *      INT0  INT1,     :
 *       D0   INT0, D1 - INT1.
 *        dat[26]:     D0 -     "0",
 *   D1 - "1".   -  .
 *     , i=26,   :
 *   fcode  1-  ( 1 - 9 (facility )   ,
 * id_l -    , id_h - .    .
 * ( bin2dec -      .)
 *   fcode, id_l, id_h c EEPROM .   ( ) -  , access_on()
 */
#include <xc.h>
#include <p18f452.h>
#pragma config OSC = HS, WDT = OFF, LVP = OFF, CCP2MUX = OFF
//------------------------------------------------------------------------------
unsigned char dat [26];//  
unsigned char fcode = 0;// facility 
unsigned char id_l = 0;//  id 
unsigned char id_h = 0;//  id 
unsigned char i = 0;//  
unsigned char card_found = 0;// " " 
unsigned char time = 0;
unsigned char time_exit = 0;//  ( )

void init(void){ 
//========================PORTS=================================================
//PORTA-------------------------------------------------------------------------    
    ADCON0bits.ADON = 0;// 
    ADCON1 = 0b00000111;//PORTA  
    TRISAbits.RA2 = 0;//Relay
    PORTAbits.RA2 = 1;//Relay on.   .
    TRISAbits.RA3 = 0;//BeepI.    
//PORTB-------------------------------------------------------------------------
    TRISBbits.RB0 = 1;//D0 input
    TRISBbits.RB1 = 1;//D1 input
    TRISBbits.RB2 = 0;//LEDGreen.  
    TRISBbits.RB3 = 0;//LEDRed.  
    TRISBbits.RB4 = 0;//Beep.   
    TRISBbits.RB5 = 1;//Exit.   .
    PORTBbits.RB3 = 1;
//PORTC-------------------------------------------------------------------------    
    TRISCbits.RC2 = 1;//Write.    EEPROM
//PORTD-------------------------------------------------------------------------    
      
//PORTE-------------------------------------------------------------------------    
    TRISEbits.RE0 = 0;//HL3."Power"  
    TRISEbits.RE1 = 0;//HL1."Access OFF"( )
    TRISEbits.RE2 = 0;//HL2."Access ON"( ) 
//===========================Interrupts=========================================    
    GIE = 1;//  
    IPEN = 1;//  
    GIEH = 1;//   
    GIEL = 1;//   
    PEIE = 1;// 
//INT0,INT1---------------------------------------------------------------------
    //INT0    
    INT1IP = 1;//  INT1    
       
    INTEDG0 = 0;//   
    INTEDG1 = 0;
        
    INT0IF = 0;//    INT0
    INT1IF = 0; 
        
    INT0IE = 1;//   INT0(RB0)
    INT1IE = 1;
//TMR1--------------------------------------------------------------------------        
    TMR1IE = 1;//   TMR1
    TMR1IP = 0;// 
    TMR1CS = 0;//Internal clock (Fosc/4))
    T1CKPS0 = 1;// 1:8
    T1CKPS1 = 1;
    TMR1 = 0x0000;//,   0  65535
    TMR1IF = 0;// 
    TMR1ON = 1;// 
}
void access_on(void){//() 
    time_exit = 0;
    RE1 = 0,RE2 = 1, RA2 = 0, RA3 = 1, RB2 = 0, RB4 = 0;
}
void access_off(void){// 
    RE1 = 1, RE2 = 0, RA2 = 1, RA3 = 0, RB2 = 1, RB4 = 1;
}
void hello(void){
    for(char i = 0; i < 3; i++){
        RE0 = RE1 = RE2 = RA3 = 1;
        time = 0;
        while(time <= 1);// 0.1    
        RE0 = RE1 = RE2 = RA3 = 0;
        time = 0;
        while(time <= 1);
        time = 0;
    }
    time = 0;
    while(time <= 5);
    access_off();
    PORTEbits.RE0 = 1;//LEDGreenP ON
}
unsigned char ee_read(unsigned char addr){//  EEPROM
    EEADR = addr;
    EEPGD = 0;
    CFGS = 0;
    RD = 1;
    while(RD)continue;
    return EEDATA;
}
void ee_write(unsigned char addr, unsigned char data){//  EEPROM
    EEADR = addr;
    EEDATA = data;
    EEPGD = 0;
    CFGS = 0;
    WREN = 1;
    GIE = 0;
    EECON2 = 0x55;
    EECON2 = 0xAA;
    WR = 1;
    while(WR)continue;
    GIE = 1;
    WREN = 0;
}
unsigned char pow(unsigned char a){
    if (a == 0) return 1;
    return 2 << (a - 1);
}
unsigned char bin2dec(int a, int b, unsigned char array[]){
    unsigned char n = 0;
    unsigned char dec = 0;
    for (int i = a; i > b; i--){
        if(array[i] == 1) dec = dec + pow(n);
        n++;
        }  
    return dec;
}
void card_search(void){//   EEPROM
    card_found = 0;
    for(int i = 0; i < 255; i=i+3){
        if(fcode == ee_read(i) && id_h == ee_read(i+1) && id_l == ee_read(i+2)){
        card_found = 1;// 
        break;
        }
    }
}
void main(void) {
    init(); 
    hello();
    unsigned char addr = ee_read(255);//    eeprom
    if(addr == 0xff)addr = 0;
    while(1){
        if(RB5 == 0)access_on();//               
        if (i >= 26){//  
            GIE = 0;
            i = 0;
            fcode = bin2dec(8,0,dat);// facility ( 8-1)
            id_l = bin2dec(24,16,dat);//   idcard (24-17)
            id_h = bin2dec(16,8,dat);//   idcard (16-9) 
            GIE = 1;
            card_search();//   eeprom
            
            if(RC2 == 0 && card_found == 0){//     ,    eeprom
                ee_write(addr,fcode);
                ee_write(addr+1,id_h);
                ee_write(addr+2,id_l);
                addr = addr+3;
                ee_write(255,addr);//   
            }            
            if(card_found == 1)access_on();
            if(card_found == 0)access_off();  
            time = 0;
            while(time <= 1)i = 0;
            card_found = 0;
            fcode = 0;
            id_l = 0;
            id_h = 0;
            i = 0;
        }        
    }     
 return;
}
void interrupt high_priority h_ir (void){
//reader1(INT0,INT1)------------------------------------------------------------    
    if (INT0IF == 1){
        INT0IF = 0;
        dat[i] = 0;
        i++; 
    }
    if(INT1IF == 1){
        INT1IF = 0;
        dat[i] = 1;
        i++; 
    }
//------------------------------------------------------------------------------    
}
void interrupt low_priority l_ir (void){   
// :1/(8000000/4/8/(65535-40535)) = 0,1.
//8000000 -  ;4 ; 8- ;65535-    ; 40535-  
    if(TMR1IF == 1)time_exit++, time++; TMR1IF = 0, TMR1 = 40535;
    if(time_exit > 30)access_off(),time_exit = 0;//    3  
}


